/////////////////////////////////////////////////////////////////////////////
// User_Defined_Casting.cpp
// ver 1.1                                                      
// Language:   C++                   
// Complier:    Visual Studio 2010, Xcode3.2.6 
// Platform:    MacBook Pro 2010
// Application:  none  
// Author:      Ider, Syracuse University  ider.cs@gmail.com
///////////////////////////////////////////////////////////////////////////


#include<iostream>
#include<string>
using namespace std;

//macro definitions
#define  IDER_DEBUG 1
#define FUNC_TRAC(info) {if(IDER_DEBUG)cout<<"----"<<info<<"----"<<endl;}

//class declaration
class Human;
class Ape;
class Programmer;

//class definition
class Programmer
{
public:
	Programmer(string where = "genius")
	{
		FUNC_TRAC("Programmer Default Constructor"); 
		from = where;
	}
	/*Programmer(Programmer& p)
	{
		FUNC_TRAC("Programmer Copy Constructor"); 
		from = p.from;
	}*/
	void Speach(){cout<<"I am a Programmer, I am "<< from <<endl;}
private:
	string from;
};

class Human 
{
public:
	Human(string where = "delivered by Parents"):heart("Human with Training")
	{
		FUNC_TRAC("Human Default Constructor"); 
		from = where;
	}
	Human(Ape& a):heart("Human with Practice")
	{
		FUNC_TRAC("Hummer Ape-Promotion Constructor");
		from = "Evolution from an Ape";
	} 
	operator Programmer() //here is weird, it is really different whether we have "&" or not
	{
		FUNC_TRAC("Hummer Programmer-Cast Operator"); 
		return heart; 
		//Programmer("Human with Practice"); // it is not good to return temporary variable
	}
	Human& operator =(Human& h)
	{
		FUNC_TRAC("Hummer Assignment Operator"); 
		cout<<"Call assignment"<<endl; 
		return *this;
	}
	void Speach(){cout<<"I am a Human, I am "<< from <<endl;}	
private:
	string from;
	Programmer heart; //Every one has a heart to be a programmer
};

class Ape 
{
public:
	Ape(string where = "from Nature")
	{
		FUNC_TRAC("Ape Default Constructor"); 
		from = where;
	}
	Ape& operator =(Programmer& p)
	{
		FUNC_TRAC("Ape Programmer-Assignment Operator"); 
		from="Degeneration from a Programmer"; 
		return *this;
	}
	/*Ape& operator =(Ape& p)
	 {
		FUNC_TRAC("Ape Assignment Operator"); 
		cout<<"Ape assign"<<endl; 
		return *this;
	 }*/
	void Speach(){cout<<"#(*%^, !@#$&)( "<< from <<endl;}
private:
	string from;
};


//main function
int main(void) {
	
	
	Ape a;
	//a.Speach();
 	Human h = a; // using promtion constructor
	//h.Speach();
	
//	Human h2;
//	h2 = a; // Error, no match assignment opeartor
	
	Programmer p = h; // using Programmer-cast operaotor
	//p.Speach();
	Programmer p0;
	p0 = h;	// using  Programmer-cast operaotor
	
	//Programmer p1 = h.operator Programmer();
	//Programmer p2 = Programmer(h);
	//Programmer p3 = (Programmer)h;

	Ape a2;
	a2 = p; //using assignment operator
	//a2.Speach();
	
//	Ape a3 = p; // Error, no match constructor

	return 0;
}



